﻿/**
 * setting--device seeting--USSD module
 * 
 * @module ussd
 * @class ussd
 */
define([ 'jquery', 'service', 'knockout'], function($, service, ko) {
	
	var initUSSD=true;
	var timeOutFlag=0;//计时
	var reply_flag=false;//是否已经得到回复
	var USSDLocation = {SEND:0, REPLY:1};
	var callbackTemp;
	var ussd_action=1;//初始化为成功获得返回消息
	var interval=0;
    var titleDiv = "" ;

    /**
     * @class USSDInformationViewModel
     * @constructor
     */
	function USSDInformationViewModel() {
		var self = this;
        var languages = service.getLanguage();
        self.ussdLanguage= ko.observable(languages.Language);
		self.ussd_action=ko.observable(ussd_action);
		self.USSDLocation=ko.observable();
		self.USSDReply=ko.observable("");
		self.USSDSend=ko.observable("");
		
		function startWith(str, str2) {
            return str.indexOf(str2) == 0;
        }

        function endWith(str, str2) {
            var lastIndex = str.lastIndexOf(str2);
            if (lastIndex >= 0) {
                return str.substring(lastIndex) == str2;
            }
            return false;
        }

        function showPromptByUssd(title,msgObj, callback, minHeight, defaultValue) {
            var option = {
                title : title,
                msg : msgObj,
                minHeight : minHeight,
                showInput : true,
                defaultValue : defaultValue
            };
            popupByUssd(option);
        }
        function popupByUssd(option) {
            $.modal.close();
            var minHeight = option.minHeight || 140;
            if(option.title == "command"){

                $('#USSD_send_div').modal({
                    focus: false,
                    position : [ "30%" ],
                    overlayId : 'confirm-overlay',
                    containerId : 'frmUSSD',
                    escClose: false,
                    minHeight : minHeight
                });
                $("div.simplemodal-wrap").removeClass("simplemodal-wrap");
                $("#USSD_send").focus();
                return;
            }else{
                $('#USSD_reply_div').modal({
                    focus: false,
                    position : [ "30%" ],
                    overlayId : 'confirm-overlay',
                    containerId : 'frmUSSD',
                    escClose: false,
                    minHeight : minHeight
                });
                $("#USSD_reply").focus();
            }

            $('.title',  '#USSD_reply_div').html($.i18n.prop(titleDiv));
        }
        self.showPayment = function(){
            $('#paymentDiv.paymentDiv').modal({
                position : [ "30%" ],
                overlayId : 'confirm-overlay',
                containerId : 'frmUSSD',
                escClose: false
            });
            $("div.simplemodal-wrap").removeClass("simplemodal-wrap");
        }
        self.closeModel = function(){
            $.modal.close();
        }
        self.sendCommand = function(){
            showPromptByUssd('command');

         }
		/**
		 * 发送USSD命令
		 * @method sendToNet
		 */
		self.sendToNet = function(item,title){
            if(title != ""){
                titleDiv = title;
            }
            var netType = service.getNetSelectInfo();
            if(checkNetType(netType.net_select)){
                showAlert('4GOnlyPro','','175px');
                return;
            }
            self.USSDSend($("#USSD_send").val());
            $("div.simplemodal-wrap").removeClass("simplemodal-wrap");
            $.modal.close();
            if(item && item != ""){
                self.USSDSend(item);
            }
            var isValid = true;
            isValid = isValid && (startWith(self.USSDSend(),"*") || startWith(self.USSDSend(),"#"));
            isValid = isValid && !(startWith(self.USSDSend(),"***") || startWith(self.USSDSend(),"####"));
            isValid = isValid && (endWith(self.USSDSend(),"*") || endWith(self.USSDSend(),"#"));
            if (!isValid) {
                showAlert2("ussd_invalide","","",titleDiv);
                return;
            }

			timeOutFlag=0;
			window.clearInterval(interval);
			var command = self.USSDSend();
			if (('string' != typeof (command)) || ('' == command)) {
				showAlert2("ussd_error_input","","",titleDiv);
				return;
			}
            /* var status = service.getStatusInfo();
			if(status.networkType == "LTE-TDD" || status.networkType == "LTE-FDD"){
               showAlert2("cus_notice_ussd","","",titleDiv);
                return;
            }*/
			showLoading("operating");
             //先ready后再发送指令
            service.USSDReplyCancel(function(result){
                if(result){
                    resetUSSD();
                    self.USSDLocation(USSDLocation.SEND);
                    var params = {};
                    params.operator = "ussd_send";
                    params.strUSSDCommand = command;
                    params.sendOrReply = "send";
					showLoading("operating");
                    service.getUSSDResponse(params, function(result, content){
                        hideLoading();
                        if(result){
                            resetUSSD();
                            self.USSDLocation(USSDLocation.REPLY);
                            self.ussd_action(content.ussd_action);
                            $("#USSD_Content").val(decodeMessage(content.data, true));
                            showPromptByUssd(title);
                            $("div.simplemodal-wrap").removeClass("simplemodal-wrap");
                            reply_flag=false;
                            timeOutFlag=0;
                            //	interval=addInterval(timeOutVerify,1000);
                        }else{
                            showAlert2(content,"","",titleDiv);
                        }
                    });
                }else{
                    showAlert2("ussd_fail","","",titleDiv);
                }
            });
		};
       self.aaa = ko.computed(function(){
            if(self.ussd_action() != 0 ){
                $("#ussd_action").show();
            } else{
                $("#ussd_action").hide();
            }
        })
		 setInterval(function(){
             if( typeof $("#USSD_reply").val() != "undefined"){
                 if($("#USSD_reply").val().length <=0){
                     disableBtn( $("#replyBtn"));
                 } else{
                     enableBtn($("#replyBtn"))
                 }
             }
        /*     if( typeof $("#USSD_send").val() != "undefined"){
                 if($("#USSD_send").val().length <=0){
                     disableBtn( $("#sendBtn"));
                 } else{
                     enableBtn($("#sendBtn"))
                 }
             }*/
             self.USSDSend($("#USSD_send").val());
        },500);
		/**
		 * 回复USSD消息
		 * @method replyToNet
		 */
		self.replyToNet = function(title){
            self.USSDReply($("#USSD_reply").val());
            $.modal.close();
            $("div.simplemodal-wrap").removeClass("simplemodal-wrap");
			timeOutFlag=0;
			window.clearInterval(interval);
			var command = self.USSDReply();
			if (('string' != typeof (command)) || ('' == command)) {
				showAlert("ussd_error_input");
				return;
			}
			showLoading("operating");
			var params = {};
                params.operator = "ussd_reply";
                params.strUSSDCommand = command;
				params.sendOrReply = "reply";
			
			service.getUSSDResponse(params, function(result, content){
				hideLoading();
				if(result){
					self.ussd_action(content.ussd_action);
					$("#USSD_Content").val(decodeMessage(content.data, true));
					reply_flag=false;
					resetUSSD();
					timeOutFlag=0;
                    showPromptByUssd(title);
                    $("div.simplemodal-wrap").removeClass("simplemodal-wrap");
					//interval=addInterval(timeOutVerify,1000);
				}else{
					showAlert(content);
				}	
			});
		};
		
		/**
		 * 取消回复USSD消息
		 * @method noReplyCancel
		 */
		self.noReplyCancel = function(){
			timeOutFlag=0;
			reply_flag=true;
			window.clearInterval(interval);
            $.modal.close();
			service.USSDReplyCancel(function(result){
				if(result){
					resetUSSD();
					self.USSDLocation(USSDLocation.SEND);
				}else{
					showAlert("ussd_fail");
				}
			});
		};
		
		/**
		 * 判断是否响应超时
		 * @method timeOutVerify
		 */
		function timeOutVerify(){
			if(!reply_flag){
				if(timeOutFlag<29){
					timeOutFlag++;
				}else{
					reply_flag=true;
					window.clearInterval(interval);
					showAlert("ussd_operation_timeout");
					self.USSDReply("");
					self.USSDSend("");
					self.USSDLocation(USSDLocation.SEND);
					timeOutFlag=0;
				}
			}else{
				reply_flag=true;
				window.clearInterval(interval);
				timeOutFlag=0;
			}
		};
		
		cancelUSSD = function(){
			service.USSDReplyCancel(function(result){
			});
		};
		
		/**
		 * 重置USSD输入命令
		 * @method resetUSSD
		 */
		resetUSSD = function(){
			self.USSDReply("");
			self.USSDSend("");
            $("#USSD_send").val("");
            $.modal.close();
		};		
		
		//如果首次进入USSD菜单，先发送USSD取消命令，进行初始化
		if(initUSSD){
			cancelUSSD();
			initUSSD=false;
		}
	}

    /**
     * 初始化
     * @method init
     */
	function init() {
		var container = $('#container')[0];
		ko.cleanNode(container);
		var vm = new USSDInformationViewModel();
		ko.applyBindings(vm, container);	
		
	}	
	
	return {
		init : init
	};
});